#include <sta/debug/printing/printable_uart.hpp>

#include <sta/debug/assert.hpp>
#include <sta/printf.hpp>

#include <cinttypes>
#include <cstring>


namespace sta
{
    
    PrintableUART::PrintableUART(UART * intf)
        : intf_{intf}
    {
        STA_ASSERT(intf != nullptr);
        STA_ASSERT(intf->settings().mode == UARTMode::RX || intf->settings().mode == UARTMode::RX_TX);
    }

    void PrintableUART::print(const char * str, size_t length, bool newline /* = false */)
    {
        const char * linebreak = "\r\n";

    	intf_->acquire();
        intf_->transfer(reinterpret_cast<const uint8_t *>(str), length);
        intf_->transfer(reinterpret_cast<const uint8_t *>(linebreak), 2);
        intf_->release();
    }

    void PrintableUART::read(char * str, size_t length)
    {
        intf_->acquire();
        intf_->receive(reinterpret_cast<uint8_t *>(str), length);
        intf_->release();
    }   

} // namespace sta
